//serverInt32.cc

#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>

#include <taskLib.h>

#include "Message.h"
#include "Int32Message.h"

class ServerInt32 {
public:
    ServerInt32(const char *name,int queueSize);
    static void server(ServerInt32 *);
private:
    int32    value;
    MessageServer *pMessageServer;
};

int serverInt32Debug=0;


ServerInt32::ServerInt32(const char *name,int queueSize)
: value(0)
{
    pMessageServer = new MessageServer(name,queueSize);
}

static char taskname[] = "serverInt32";
extern "C" int initServerInt32(const char *serverName,int queueSize)
{
    ServerInt32 *pServerInt32 = new ServerInt32(serverName,queueSize);
    int taskId = taskSpawn(taskname,100,VX_FP_TASK,2000,
         (FUNCPTR)ServerInt32::server,(int)pServerInt32, 0,0,0,0,0,0,0,0,0);
    if(taskId==ERROR)
        printf("initServerInt32 taskSpawn Failure\n");
    return(0);
}

void ServerInt32::server(ServerInt32 *pServerInt32)
{
    MessageServer *pMessageServer = pServerInt32->pMessageServer;
    pServerInt32->value = 0;
    bool allocNew = false;
    while(TRUE) {
	pMessageServer->waitForMessage();
	Message *message;
	while((message = pMessageServer->receive())) {
	    if(message->getType()!=messageTypeInt32) {
	        printf("serverInt32 got illegal message type %d\n",
		    message->getType());
	    } else {
		Int32Message  *preceive = (Int32Message *)message;
		Int32Message *psend;
		pServerInt32->value = preceive->value;
		if(allocNew) {
		    psend = (Int32Message *)pMessageServer->
			allocReplyMessage(preceive,messageTypeInt32);
		    delete preceive;
		    allocNew = false;
		    psend->value = pServerInt32->value;
		} else {
	            psend = preceive;
		    allocNew = true;
		}
		if(serverInt32Debug) {
		    char buffer[100];

		    sprintf(buffer,"server value %d psend %p\n",
			    pServerInt32->value,psend);
		    printf("%s",buffer);
		}
	        pMessageServer->reply(psend);
	    }
	}
    }
}
